unit KlimatUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, Grids, StdCtrls, ExtCtrls, RXCtrls, Klimat, Registry;


type
  TKlimatForm = class(TForm)
    GroupBox2: TGroupBox;
    ToolBar1: TToolBar;
    AddBut: TToolButton;
    DelBut: TToolButton;
    SaveButton: TToolButton;
    ListBox1: TListBox;
    KlimEdit: TStringGrid;
    Panel1: TPanel;
    Gorod: TEdit;
    RxLabel1: TRxLabel;
    ToolButton4: TToolButton;
    KomEdit: TEdit;
    RxLabel2: TRxLabel;
    OpenDialog1: TOpenDialog;
    procedure AddButClick(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure GorodChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DelButClick(Sender: TObject);
    procedure KlimEditSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure ToolButton4Click(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure KomEditChange(Sender: TObject);
    procedure GorodKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
    Modify: boolean;
    path_klimat:string;
    reg  : TRegistry;
  public
    { Public declarations }
     FilKlimat: TFileStream;
    _KlimClass: TKlimClass;
    procedure LoadKlimLib;
    procedure SeekKlimat;
  end;

var
  KlimatForm: TKlimatForm;
  KlimClass:TKlimClass;
  KlimRec: TKlimRec;

implementation



{$R *.dfm}

procedure TKlimatForm.AddButClick(Sender: TObject);
begin
  KlimClass:=TKlimClass.Create;
  KlimClass.KlimRec.MestoGrd:=' ';
  ListBox1.Items.AddObject(KlimClass.KlimRec.MestoGrd,KlimClass);
  Modify:=true;
end;

procedure TKlimatForm.ListBox1Click(Sender: TObject);
begin
 if ListBox1.Items.Count=0 then begin AddButClick(Sender); exit; end;
 KlimClass:=ListBox1.Items.Objects[ListBox1.ItemIndex] as TKlimClass;
 Gorod.Text:=KlimClass.KlimRec.MestoGrd;
 KomEdit.Text:=KlimClass.KlimRec.Komentar;
 KlimEdit.Cells[2,1]:=  KlimClass.KlimRec.Pbar;
 KlimEdit.Cells[2,2]:=  KlimClass.KlimRec.TnB;
 KlimEdit.Cells[2,3]:=  KlimClass.KlimRec.TnA;
 KlimEdit.Cells[2,4]:=  KlimClass.KlimRec.VetrB;
 KlimEdit.Cells[2,5]:=  KlimClass.KlimRec.VetrA;
 KlimEdit.Cells[2,6]:=  KlimClass.KlimRec.Period;
 KlimEdit.Cells[2,7]:=  KlimClass.KlimRec.T_Period;
 KlimEdit.Cells[2,8]:=  KlimClass.KlimRec.OtNVlag_Zima;
 KlimEdit.Cells[2,9]:=  KlimClass.KlimRec.OtNVlag_Leto;
 KlimEdit.Cells[2,10]:= KlimClass.KlimRec.TnLeto;

end;

procedure TKlimatForm.GorodChange(Sender: TObject);
begin
 ListBox1.Items.Strings[ListBox1.ItemIndex]:=Gorod.Text;
 KlimClass.KlimRec.MestoGrd:=Gorod.Text;
end;


procedure TKlimatForm.FormCreate(Sender: TObject);
var i  : byte;
begin
_KlimClass:=TKlimClass.Create;
 path_klimat:=ExtractFilePath(Application.ExeName);

Modify:=false;
for i :=1  to KlimEdit.RowCount do KlimEdit.Cells[0,i]:=IntToStr(i);
KlimEdit.Cells[0,0]:=''; KlimEdit.Cells[1,0]:='';      KlimEdit.Cells[2,0]:='';
KlimEdit.Cells[1,1]:= ' , .';
KlimEdit.Cells[1,2]:= '  ,  ';
KlimEdit.Cells[1,3]:= '  ,  ';
KlimEdit.Cells[1,4]:= ' ,  , /';
KlimEdit.Cells[1,5]:= ' ,  , /';
KlimEdit.Cells[1,6]:= ' ,  ';
KlimEdit.Cells[1,7]:= '  . , Ѱ';
KlimEdit.Cells[1,8]:= '  , %';
KlimEdit.Cells[1,9]:= '  , %';
KlimEdit.Cells[1,10]:='   , Ѱ';

LoadKlimLib;
end;

procedure TKlimatForm.SeekKlimat;
begin
   if ListBox1.Items.IndexOf(_KlimClass.KlimRec.MestoGrd)>-1 then
       ListBox1.ItemIndex:=ListBox1.Items.IndexOf(_KlimClass.KlimRec.MestoGrd)
    else begin   Modify:=true;
            KlimClass:=TKlimClass.Create;
            KlimClass.KlimRec:=_KlimClass.KlimRec;
            KlimClass.KlimRec.MestoGrd:='  ';
            ListBox1.ItemIndex:=ListBox1.Items.AddObject(KlimClass.KlimRec.MestoGrd,KlimClass);
            ShowMessage('    .'+#13+'          '+#13
            + '   . '); //     RTI,
         end;
ListBox1Click(nil);
end;


procedure TKlimatForm.DelButClick(Sender: TObject);
begin
 ListBox1.Items.Delete(ListBox1.ItemIndex);
end;

procedure TKlimatForm.KlimEditSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
 case ARow of
   1: KlimClass.KlimRec.Pbar    :=     KlimEdit.Cells[2,1];
   2: KlimClass.KlimRec.TnB     :=     KlimEdit.Cells[2,2];
   3: KlimClass.KlimRec.TnA     :=     KlimEdit.Cells[2,3];
   4: KlimClass.KlimRec.VetrB   :=     KlimEdit.Cells[2,4];
   5: KlimClass.KlimRec.VetrA   :=     KlimEdit.Cells[2,5];
   6: KlimClass.KlimRec.Period  :=     KlimEdit.Cells[2,6];
   7: KlimClass.KlimRec.T_Period:=     KlimEdit.Cells[2,7];
   8: KlimClass.KlimRec.OtNVlag_Zima:= KlimEdit.Cells[2,8];
   9: KlimClass.KlimRec.OtNVlag_Leto:= KlimEdit.Cells[2,9];
  10: KlimClass.KlimRec.TnLeto:=       KlimEdit.Cells[2,10];
 end;     Modify:=true;
end;

procedure TKlimatForm.ToolButton4Click(Sender: TObject);
begin
Close;
end;

procedure TKlimatForm.SaveButtonClick(Sender: TObject);
var i:byte;
    s:string[3];
begin
   FilKlimat:=TFileStream.Create(path_klimat+'klim_st.lib',fmCreate);
  try
   for i:=0 to ListBox1.Items.Count-1 do
    begin
     if not (ListBox1.Items.Objects[i] is TKlimClass) then exit;
     KlimClass:=ListBox1.Items.Objects[i] as TKlimClass;
     FilKlimat.Write(KlimClass.KlimRec,SizeOf(TKlimRec));
     s:='~'; FilKlimat.Write(s,SizeOf(s));
    end;
   finally
    FilKlimat.Destroy;
   end;                 Modify:=false;
end;

procedure TKlimatForm.LoadKlimLib;
var  s:string[3];
begin

try
 FilKlimat:=TFileStream.Create(path_klimat+'klim_st.lib',fmOpenRead);

except exit; end;
try
 while FilKlimat.Position<>FilKlimat.Size do
  begin
   KlimClass:=TKlimClass.Create;
   FilKlimat.Read(KlimClass.KlimRec,SizeOf(TKlimRec));
   FilKlimat.Read(s,SizeOf(s));
   ListBox1.Items.AddObject(KlimClass.KlimRec.MestoGrd,KlimClass)
  end;
finally
   FilKlimat.Destroy;
end;

end;

procedure TKlimatForm.KomEditChange(Sender: TObject);
begin
 KlimClass.KlimRec.Komentar:=KomEdit.Text;
end;

procedure TKlimatForm.GorodKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Modify:=true;
end;

procedure TKlimatForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin

if Modify then
begin
KlimatForm.FormStyle:=fsNormal;
case Application.MessageBox('    .'+#13+' C   ?',' !!! ',
			   MB_YESNOCANCEL or MB_ICONQUESTION)  of
		 IDYes: begin SaveButtonClick(Sender); CanClose:=True;end;
		 IDNo : CanClose:=True;
		 IDCancel : begin CanClose:=False;KlimatForm.FormStyle:=fsStayOnTop;end;
    end;

end;
end;

end.
