unit RezPodbr;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ImgList, ToolWin, Word2000, OleServer;

type
  TRezPodbrFrm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    RezRichEdit: TRichEdit;
    ProtokRichEdit: TRichEdit;
    StandardToolBar: TToolBar;
    OpenButton: TToolButton;
    SaveButton: TToolButton;
    PrintButton: TToolButton;
    EksportWordBut: TToolButton;
    ToolButton5: TToolButton;
    CutButton: TToolButton;
    CopyButton: TToolButton;
    PasteButton: TToolButton;
    UndoButton: TToolButton;
    ToolButton10: TToolButton;
    FontName: TComboBox;
    ToolButton11: TToolButton;
    FontSize: TEdit;
    UpDown1: TUpDown;
    ToolButton2: TToolButton;
    BoldButton: TToolButton;
    ItalicButton: TToolButton;
    UnderlineButton: TToolButton;
    ToolButton16: TToolButton;
    ToolButton1: TToolButton;
    LeftAlign: TToolButton;
    CenterAlign: TToolButton;
    RightAlign: TToolButton;
    ToolButton20: TToolButton;
    BulletsButton: TToolButton;
    ExitBtn: TToolButton;
    ToolbarImages: TImageList;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    PrintDialog1: TPrintDialog;
    FindDialog1: TFindDialog;
    procedure ExitBtnClick(Sender: TObject);
    procedure OpenButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PageControl1Change(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure PrintButtonClick(Sender: TObject);
    procedure EksportWordButClick(Sender: TObject);
    procedure CutButtonClick(Sender: TObject);
    procedure CopyButtonClick(Sender: TObject);
    procedure PasteButtonClick(Sender: TObject);
    procedure UndoButtonClick(Sender: TObject);
    procedure FontNameChange(Sender: TObject);
    procedure FontSizeChange(Sender: TObject);
    procedure BoldButtonClick(Sender: TObject);
    procedure ItalicButtonClick(Sender: TObject);
    procedure UnderlineButtonClick(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure LeftAlignClick(Sender: TObject);
    procedure CenterAlignClick(Sender: TObject);
    procedure RightAlignClick(Sender: TObject);
    procedure BulletsButtonClick(Sender: TObject);
  private
    { Private declarations }
   //-------  Word ------------
     ovFileName, vstart, vend : OleVariant;
     ACol, ARow : byte;
     j, ilengy: Integer;
     WordApplication1:TWordApplication;
     WordDocument1:TWordDocument;
     WordParagraphFormat1:TWordParagraphFormat;
     verr,verr1:string;
     i,verrI:integer;
     //-------  Word ------------
    TempRichEdit:TRichEdit;
    procedure Error(i:integer;str:string);
    function ProverkaWord200XP:boolean;
    function CurrText: TTextAttributes;
  public
    { Public declarations }
  end;

const DigiChar = ['0','1','2','3','4','5','6','7','8','9']; //-------  Word ------------

var
  RezPodbrFrm: TRezPodbrFrm;


implementation

{$R *.dfm}

function TRezPodbrFrm.CurrText: TTextAttributes;
begin
  if TempRichEdit.SelLength > 0 then Result:=TempRichEdit.SelAttributes
  else Result:=TempRichEdit.DefAttributes;
end;

procedure TRezPodbrFrm.ExitBtnClick(Sender: TObject);
begin
close;
end;

procedure TRezPodbrFrm.OpenButtonClick(Sender: TObject);
begin
if OpenDialog1.Execute then
  begin
   TempRichEdit.Lines.LoadFromFile(OpenDialog1.FileName);
   caption:=OpenDialog1.FileName;
  end;
end;

procedure TRezPodbrFrm.FormCreate(Sender: TObject);
begin
TempRichEdit:=RezRichEdit;
end;

procedure TRezPodbrFrm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
Action:=caFree;
end;

procedure TRezPodbrFrm.PageControl1Change(Sender: TObject);
begin
if PageControl1.ActivePageIndex=0 then TempRichEdit:=RezRichEdit else TempRichEdit:=ProtokRichEdit;
end;

procedure TRezPodbrFrm.SaveButtonClick(Sender: TObject);
begin
if SaveDialog1.Execute then TempRichEdit.Lines.SaveToFile(SaveDialog1.FileName+'.txt')
end;

procedure TRezPodbrFrm.Error(i:integer;str:string);
begin
 case i of
  1:begin showmessage(str);
      showmessage('  ');
    //  Application.Terminate;
	end;
  2:begin showmessage(str);
     showmessage('  ');
    // Application.Terminate;
    end;
 end;
 showmessage(str);
 Exit;
end;

function TRezPodbrFrm.ProverkaWord200XP:boolean;
var i:integer;
begin
 verr:=Trim(WordApplication1.Version);
 verr1:='';
 for i:=1 to Length(verr) do
  if not(verr[i] in DigiChar) then break
  else verr1:=verr1+verr[i];
 verrI:=StrToInt(verr1);
 result:=verrI>9;
 if verrI<9 then error(1,' WORD 2000/XP  ');

end;

procedure TRezPodbrFrm.PrintButtonClick(Sender: TObject);
begin
  if PrintDialog1.Execute then TempRichEdit.Print(' ');
end;

procedure TRezPodbrFrm.EksportWordButClick(Sender: TObject);
begin
try
WordApplication1:=TWordApplication.Create(TempRichEdit);
WordDocument1:=TWordDocument.Create(TempRichEdit);
WordParagraphFormat1:=TWordParagraphFormat.Create(TempRichEdit);
 except
  error(1,'  Microsoft Word.');
 end;

 if ProverkaWord200XP then else exit;

WordApplication1.Connect;
WordApplication1.Documents.Add(EmptyParam, EmptyParam, EmptyParam, EmptyParam);
WordApplication1.ActiveDocument.PageSetup.Orientation:=wdOrientPortrait;
WordDocument1.ConnectTo(WordApplication1.ActiveDocument);
WordApplication1.Options.CheckSpellingAsYouType:=False;
//WordApplication1.Options.CheckGrammarAsYouType:=False;
TempRichEdit.SelectAll;
TempRichEdit.CopyToClipboard;
TempRichEdit.SelLength:=0;
WordDocument1.PageSetup.Orientation:=0;
WordApplication1.Selection.Paste;
WordApplication1.Visible:=True;
WordApplication1.Activate;
WordApplication1.Disconnect;
WordApplication1.Destroy;

end;

procedure TRezPodbrFrm.CutButtonClick(Sender: TObject);
begin
  TempRichEdit.CutToClipboard;
end;

procedure TRezPodbrFrm.CopyButtonClick(Sender: TObject);
begin
  TempRichEdit.CopyToClipboard;
end;

procedure TRezPodbrFrm.PasteButtonClick(Sender: TObject);
begin
  TempRichEdit.PasteFromClipboard;
end;

procedure TRezPodbrFrm.UndoButtonClick(Sender: TObject);
begin
   with TempRichEdit do if HandleAllocated then SendMessage(Handle, EM_UNDO, 0, 0);
end;

procedure TRezPodbrFrm.FontNameChange(Sender: TObject);
begin
  //if not f_Updating then
   CurrText.Name:=FontName.Items[FontName.ItemIndex];
end;

procedure TRezPodbrFrm.FontSizeChange(Sender: TObject);
begin
if (TempRichEdit.SelLength<1) and (FontSize.Tag>0) then  TempRichEdit.SelectAll;
  CurrText.Size:=StrToInt(FontSize.Text);
  FontSize.Tag:=1;
end;

procedure TRezPodbrFrm.BoldButtonClick(Sender: TObject);
begin
 if BoldButton.Down then
    CurrText.Style:=CurrText.Style + [fsBold]
  else
    CurrText.Style:=CurrText.Style - [fsBold];
end;

procedure TRezPodbrFrm.ItalicButtonClick(Sender: TObject);
begin
  if ItalicButton.Down then
    CurrText.Style:=CurrText.Style + [fsItalic]
  else
    CurrText.Style:=CurrText.Style - [fsItalic];
end;

procedure TRezPodbrFrm.UnderlineButtonClick(Sender: TObject);
begin
  if UnderlineButton.Down then
    CurrText.Style:=CurrText.Style + [fsUnderline]
  else
    CurrText.Style:=CurrText.Style - [fsUnderline];

end;

procedure TRezPodbrFrm.ToolButton1Click(Sender: TObject);
begin
FindDialog1.Execute;
end;

procedure TRezPodbrFrm.FindDialog1Find(Sender: TObject);
var
  FoundAt: LongInt;
  StartPos, ToEnd: integer;
begin
  with TempRichEdit do
  begin
    if SelLength <> 0 then
      StartPos := SelStart + SelLength
    else
    StartPos := 0;

    ToEnd := Length(Text) - StartPos;
    FoundAt := FindText(FindDialog1.FindText, StartPos, ToEnd, [stMatchCase]);
    if FoundAt <> -1 then
    begin
      SetFocus;
      SelStart := FoundAt;
      SelLength := Length(FindDialog1.FindText);
    end;
  end;
end;

procedure TRezPodbrFrm.LeftAlignClick(Sender: TObject);
begin
TempRichEdit.Paragraph.Alignment:=taLeftJustify;
end;

procedure TRezPodbrFrm.CenterAlignClick(Sender: TObject);
begin
TempRichEdit.Paragraph.Alignment:=taCenter;
end;

procedure TRezPodbrFrm.RightAlignClick(Sender: TObject);
begin
TempRichEdit.Paragraph.Alignment:=taRightJustify;
end;

procedure TRezPodbrFrm.BulletsButtonClick(Sender: TObject);
begin
TempRichEdit.Paragraph.Numbering:=TNumberingStyle(BulletsButton.Down);
end;

end.
